DL_PrivateKey_ECGDSA< EC > Class Template Reference

Elliptic Curve German DSA key for ISO/IEC 15946. More...

`#include <eccrypto.h>`

Inheritance diagram for DL_PrivateKey_ECGDSA< EC >:

## Public Types

typedef EC::Point | Element
Public Types inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
typedef GP::Element | Element
Public Types inherited from DL_PrivateKey< GP::Element >
typedef GP::Element | Element
Public Types inherited from DL_KeyImpl< PK, GP, O >
typedef GP | GroupParameters

## Public Member Functions

void | Initialize (const DL_GroupParameters_EC< EC > &params, const Integer &x)
| Initialize an EC Private Key using {GP,x}.
void | Initialize (const EC &ec, const Element &G, const Integer &n, const Integer &x)
| Initialize an EC Private Key using {EC,G,n,x}.
void | Initialize (RandomNumberGenerator &rng, const DL_GroupParameters_EC< EC > &params)
| Create an EC private key.
void | Initialize (RandomNumberGenerator &rng, const EC &ec, const Element &G, const Integer &n)
| Create an EC private key.
virtual void | MakePublicKey (DL_PublicKey_ECGDSA< EC > &pub) const
virtual bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
virtual void | AssignFrom (const NameValuePairs &source)
void | BERDecodePrivateKey (BufferedTransformation &bt, bool parametersPresent, size_t size)
void | DEREncodePrivateKey (BufferedTransformation &bt) const
Public Member Functions inherited from DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params)
| Generate a random key or crypto parameters.
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation.
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
const DL_GroupParameters< Element > & | GetAbstractGroupParameters () const
| Retrieves abstract group parameters.
DL_GroupParameters< Element > & | AccessAbstractGroupParameters ()
| Retrieves abstract group parameters.
const Integer & | GetPrivateExponent () const
| Retrieves the private exponent.
void | SetPrivateExponent (const Integer &x)
| Sets the private exponent.
void | BERDecodePrivateKey (BufferedTransformation &bt, bool, size_t)
| Decode privateKey part of privateKeyInfo.
void | DEREncodePrivateKey (BufferedTransformation &bt) const
| Encode privateKey part of privateKeyInfo.
Public Member Functions inherited from DL_PrivateKey< GP::Element >
void | MakePublicKey (DL_PublicKey< GP::Element > &pub) const
| Initializes a public key from this key.
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Initialize or reinitialize this key.
Public Member Functions inherited from DL_KeyImpl< PK, GP, O >
O | GetAlgorithmID () const
bool | BERDecodeAlgorithmParameters (BufferedTransformation &bt)
bool | DEREncodeAlgorithmParameters (BufferedTransformation &bt) const
const GP & | GetGroupParameters () const
GP & | AccessGroupParameters ()

## Detailed Description

template<class EC>
class DL_PrivateKey_ECGDSA< EC >

Elliptic Curve German DSA key for ISO/IEC 15946.

Template Parameters

  EC | elliptic curve field

See also
  ECGDSA

Since
  Crypto++ 6.0

Definition at line 418 of file eccrypto.h.

## Member Typedef Documentation

## Element

template<class EC >

typedef EC::Point DL_PrivateKey_ECGDSA< EC >::Element

Definition at line 421 of file eccrypto.h.

## Constructor & Destructor Documentation

## ~DL_PrivateKey_ECGDSA()

template<class EC >

virtual DL_PrivateKey_ECGDSA< EC >::~DL_PrivateKey_ECGDSA | ( |  | ) |

inline virtual

Definition at line 423 of file eccrypto.h.

## Member Function Documentation

## Initialize() [1/4]

template<class EC >

void DL_PrivateKey_ECGDSA< EC >::Initialize | ( | const DL_GroupParameters_EC< EC > & | params,
|  | const Integer & | x
| ) |  |

inline

Initialize an EC Private Key using {GP,x}.

Parameters

  params | group parameters
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 429 of file eccrypto.h.

## Initialize() [2/4]

template<class EC >

void DL_PrivateKey_ECGDSA< EC >::Initialize | ( | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n,
|  | const Integer & | x
| ) |  |

inline

Initialize an EC Private Key using {EC,G,n,x}.

Parameters

  ec | the elliptic curve
  G | the base point
  n | the order of the base point
  x | the private exponent

This Initialize() function overload initializes a private key from existing parameters.

Definition at line 442 of file eccrypto.h.

## Initialize() [3/4]

template<class EC >

void DL_PrivateKey_ECGDSA< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const DL_GroupParameters_EC< EC > & | params
| ) |  |

inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  params | the EC group parameters

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 455 of file eccrypto.h.

## Initialize() [4/4]

template<class EC >

void DL_PrivateKey_ECGDSA< EC >::Initialize | ( | RandomNumberGenerator & | rng,
|  | const EC & | ec,
|  | const Element & | G,
|  | const Integer & | n
| ) |  |

inline

Create an EC private key.

Parameters

  rng | a RandomNumberGenerator derived class
  ec | the elliptic curve
  G | the base point
  n | the order of the base point

This function overload of Initialize() creates a new private key because it takes a RandomNumberGenerator() as a parameter. If you have an existing keypair, then use one of the other Initialize() overloads.

Definition at line 466 of file eccrypto.h.

## MakePublicKey()

template<class EC >

virtual void DL_PrivateKey_ECGDSA< EC >::MakePublicKey | ( | DL_PublicKey_ECGDSA< EC > & | pub | ) | const

inline virtual

Definition at line 469 of file eccrypto.h.

## GetVoidValue()

template<class EC >

virtual bool DL_PrivateKey_ECGDSA< EC >::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const

inline virtual

Definition at line 478 of file eccrypto.h.

## AssignFrom()

template<class EC >

virtual void DL_PrivateKey_ECGDSA< EC >::AssignFrom | ( | const NameValuePairs & | source | ) |

inline virtual

Definition at line 484 of file eccrypto.h.

The documentation for this class was generated from the following file:

- eccrypto.h